TagLib::Ogg::File Class Reference

An implementation of TagLib::File with some helpers for Ogg based formats. More...

`#include <oggfile.h>`

Inheritance diagram for TagLib::Ogg::File:
[legend]
Collaboration diagram for TagLib::Ogg::File:
[legend]

## Public Member Functions

| ~File () override
| File (const File &)=delete
File & | operator= (const File &)=delete
ByteVector | packet (unsigned int i)
void | setPacket (unsigned int i, const ByteVector &p)
const PageHeader * | firstPageHeader ()
const PageHeader * | lastPageHeader ()
bool | save () override
Public Member Functions inherited from TagLib::File
| File (const File &)=delete
File & | operator= (const File &)=delete
FileName | name () const
virtual Tag * | tag () const =0
virtual PropertyMap | properties () const
virtual void | removeUnsupportedProperties (const StringList &properties)
virtual PropertyMap | setProperties (const PropertyMap &properties)
virtual StringList | complexPropertyKeys () const
virtual List< VariantMap > | complexProperties (const String &key) const
virtual bool | setComplexProperties (const String &key, const List< VariantMap > &value)
virtual AudioProperties * | audioProperties () const =0
ByteVector | readBlock (size_t length)
void | writeBlock (const ByteVector &data)
offset_t | find (const ByteVector &pattern, offset_t fromOffset=0, const ByteVector &before=ByteVector())
offset_t | rfind (const ByteVector &pattern, offset_t fromOffset=0, const ByteVector &before=ByteVector())
void | insert (const ByteVector &data, offset_t start=0, size_t replace=0)
void | removeBlock (offset_t start=0, size_t length=0)
bool | readOnly () const
bool | isOpen () const
bool | isValid () const
void | seek (offset_t offset, Position p=Beginning)
void | clear ()
offset_t | tell () const
offset_t | length ()

## Protected Member Functions

| File (FileName file)
| File (IOStream *stream)
Protected Member Functions inherited from TagLib::File
| File (FileName fileName)
| File (IOStream *stream)
void | setValid (bool valid)
void | truncate (offset_t length)

## Additional Inherited Members

Public Types inherited from TagLib::File
enum | Position { Beginning , Current , End }
enum | StripTags { StripNone , StripOthers }
enum | DuplicateTags { Duplicate , DoNotDuplicate }
Static Protected Member Functions inherited from TagLib::File
static unsigned int | bufferSize ()

## Detailed Description

An implementation of TagLib::File with some helpers for Ogg based formats.

This is an implementation of Ogg file page and packet rendering and is of use to Ogg based formats. While the API is small this handles the non-trivial details of breaking up an Ogg stream into packets and makes these available (via subclassing) to the codec metadata implementations.

## Constructor & Destructor Documentation

## ~File()

TagLib::Ogg::File::~File | ( |  | ) |

override virtual

Destroys this File instance.

Reimplemented from TagLib::File.

Reimplemented in TagLib::Ogg::FLAC::File, TagLib::Ogg::Opus::File, TagLib::Ogg::Speex::File, and TagLib::Ogg::Vorbis::File.

## File() [1/3]

TagLib::Ogg::File::File | ( | const File & |  | ) |

delete

References File().

Referenced by File(), and operator=().

## File() [2/3]

TagLib::Ogg::File::File | ( | FileName | file | ) |

protected

Constructs an Ogg file from file.

Note
  This constructor is protected since Ogg::File shouldn't be instantiated directly but rather should be used through the codec specific subclasses.

## File() [3/3]

TagLib::Ogg::File::File | ( | IOStream * | stream | ) |

protected

Constructs an Ogg file from stream.

Note
  This constructor is protected since Ogg::File shouldn't be instantiated directly but rather should be used through the codec specific subclasses.
  TagLib will not take ownership of the stream, the caller is responsible for deleting it after the File object.

References packet(), and TAGLIB_MSVC_SUPPRESS_WARNING_NEEDS_TO_HAVE_DLL_INTERFACE.

## Member Function Documentation

## firstPageHeader()

const PageHeader * TagLib::Ogg::File::firstPageHeader | ( |  | ) |

Returns a pointer to the PageHeader for the first page in the stream or null if the page could not be found.

## lastPageHeader()

const PageHeader * TagLib::Ogg::File::lastPageHeader | ( |  | ) |

Returns a pointer to the PageHeader for the last page in the stream or null if the page could not be found.

## operator=()

File & TagLib::Ogg::File::operator= | ( | const File & |  | ) |

delete

References File().

## packet()

ByteVector TagLib::Ogg::File::packet | ( | unsigned int | i | ) |

Returns the packet contents for the i-th packet (starting from zero) in the Ogg bitstream.

Warning
  This requires reading at least the packet header for every page up to the requested page.

Referenced by File().

## save()

bool TagLib::Ogg::File::save | ( |  | ) |

override virtual

Save the file and its associated tags. This should be reimplemented in the concrete subclasses. Returns `true` if the save succeeds.

Warning
  On UNIX multiple processes are able to write to the same file at the same time. This can result in serious file corruption. If you are developing a program that makes use of TagLib from multiple processes you must insure that you are only doing writes to a particular file from one of them.

Implements TagLib::File.

Reimplemented in TagLib::Ogg::FLAC::File, TagLib::Ogg::Opus::File, TagLib::Ogg::Speex::File, and TagLib::Ogg::Vorbis::File.

## setPacket()

void TagLib::Ogg::File::setPacket | ( | unsigned int | i,
|  | const ByteVector & | p )

Sets the packet with index i to the value p.

The documentation for this class was generated from the following file:

- oggfile.h